"use strict";
/*Теоретичні питання
1. Опишіть своїми словами як працює метод forEach.
2. Які методи для роботи з масивом мутують існуючий масив, а які повертають новий масив? Наведіть приклади.
3. Як можна перевірити, що та чи інша змінна є масивом?
4. В яких випадках краще використовувати метод map(), а в яких forEach()?

Практичні завдання
1. Створіть масив з рядків "travel", "hello", "eat", "ski", "lift"
 та обчисліть кількість рядків з довжиною більше за 3 символи. Вивести це число в консоль.
2. Створіть масив із 4 об'єктів, які містять інформацію про людей: {name: "Іван", age: 25, sex: "чоловіча"}. 
Наповніть різними даними. Відфільтруйте його, щоб отримати тільки об'єкти зі sex "чоловіча".
Відфільтрований масив виведіть в консоль.
3. Реалізувати функцію фільтру масиву за вказаним типом даних. (Опціональне завдання)
Технічні вимоги:
- Написати функцію filterBy(), 
яка прийматиме 2 аргументи. Перший аргумент - масив, який міститиме будь-які дані, 
другий аргумент - тип даних.
- Функція повинна повернути новий масив, 
який міститиме всі дані, які були передані в аргумент, 
за винятком тих, тип яких був переданий другим аргументом.
 Тобто якщо передати масив ['hello', 'world', 23, '23', null],
  і другим аргументом передати 'string', то функція поверне масив [23, null].*/

//   Теоритичні питання
// 1. forEach використовується для робити з елементами в масиві
// 2. Мутуючі push(), pop(), shift(), unshift(), slice().
//    Методи які повертають новий масив concat(),concat(),map(), filter().
// 3. Array.isArray() , typeOf()
// 4. forEach() — виконує вказану функцію кожного елемента масиву.
//    map() — створює новий масив із результатом виклику зазначеної функції кожного елемента масиву.

// Практичні завдання

// Завдання 1

// let words = ["travel", "hello", "eat", "ski", "lift"];
// let countWords = 0;

// function calculate(words) {
//   words.forEach((item, index) => {
//     console.log(item, index);
//     let wordLength = item.length;
//     if (wordLength > 3) {
//       countWords++;
//     }
//   });

//   return countWords;
// }

// let result = calculate(words);
// console.log(`Кількість слів з більше, ніж 3 букви: ${result}`);

// calculate(words);

// Завдання 2

// let info = [
//   { name: "Андрій", age: "45", sex: "Чоловіча" },
//   { name: "Аліна", age: "25", sex: "Жіноча" },
//   { name: "Генадій", age: "12", sex: "Чоловіча" },
//   { name: "Ольга", age: "40", sex: "Жіноча" },
// ];
// let sexItem = info.filter(comp);
// function comp(person) {
//   return person.sex === "Чоловіча";
// }

// console.log(sexItem);

// Завдання 3 взято з чат гпт цікаво чи воно вважається
// за правильно що б я його розібрав бо я йому не довіряю

// function filterBy(dataArray, dataType) {
//   return dataArray.filter((item) => typeof item !== dataType);
// }

// let inputArray = ["hello", "world", 23, "23", null];
// let filteredArray = filterBy(inputArray, "string");
// console.log(filteredArray);
